# -*- coding: utf-8 -*-
from setuphelpers import *


def install():

    if Version(windows_version()) > Version("10.0"):
        registry_set(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\Windows\Windows Search", r"AllowCortana", 0, REG_DWORD)
        try:
            remove_appx("Microsoft.549981C3F5F10", default_user=False)
            remove_appx("Microsoft.Windows.Cortana", default_user=False)
        except:
            print("At least one Cortana Appx uninstallation failed, It is most likely normal depending on the Windows version")
    else:
        print("This Windows version do not need to disable Cortana")


def uninstall():

    if Version(windows_version()) > Version("10.0"):
        registry_delete(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\Windows\Windows Search", r"AllowCortana")
        try:
            run_powershell(
                r'Get-AppxPackage -Name Microsoft.549981C3F5F10 -AllUsers | Foreach {Add-AppxPackage -DisableDevelopmentMode -Register "$($_.InstallLocation)\AppXManifest.xml"}'
            )
            run_powershell(
                r'Get-AppxPackage -Name Microsoft.Windows.Cortana -AllUsers | Foreach {Add-AppxPackage -DisableDevelopmentMode -Register "$($_.InstallLocation)\AppXManifest.xml"}'
            )
        except:
            print("At least one Cortana Appx reinstallation failed, It is most likely normal depending on the Windows version")


def remove_appx(package, default_user=True):

    if running_as_admin() or running_as_system():
        run_powershell('Get-AppxPackage "%s" -AllUsers | Remove-AppxPackage -AllUsers' % package)
        if default_user:
            run_powershell(
                'Get-AppXProvisionedPackage -Online | Where-Object DisplayName -Like "%s" | Remove-AppxProvisionedPackage -Online -AllUsers' % package
            )
    else:
        run_powershell('Get-AppxPackage "%s" | Remove-AppxPackage' % package)
